<?php

$pxp_file = 'characters_pxp/disco/bigman4_normal_steam.pxt';

$out_file = $pxp_file.'.decomp.out.txt';

if(isset($argv) && count($argv) > 1) {
	$pxp_file = $argv[1];
	$out_file = str_replace('_pxp', '', $argv[1]);
}

/*
Different modes for offset/length doublebyte
Length +3
Offset +1
*/
define('MODE_VERYMUCHNEAR', 1); // 7 L 9 0 (!!!! oO ;-)
define('MODE_VERYMUCHNEAR_DD', 2);
define('MODE_VERYMUCHNEAR_Q4D', 3);
define('MODE_VERYNEAR', 4); // 6 L 10 O
define('MODE_VERYNEAR_DD', 5);
define('MODE_VERYNEAR_Q4D', 6);
define('MODE_NEAR', 7); // 5 L 11 O
define('MODE_NEAR_DD', 8); // 5 L (11 O) * 2 + 1
define('MODE_NEAR_Q4D', 9); // 5 L (11 O) * 4 + 3
define('MODE_FAR', 10); // 4 L 12 O
define('MODE_FAR_DD', 11);
define('MODE_FAR_Q4D', 12);
define('MODE_VERYFAR', 13); // 3 L 13 O
define('MODE_VERYFAR_DD', 14); // 3 L (13 O) * 2 + 1
define('MODE_VERYFAR_Q4D', 15);

define('MODE_ZERO', 16); // no compression

$file = file_get_contents($pxp_file);

if(!$file) die('file not found');

echo " '$pxp_file'\n";

$fs = filesize($pxp_file);

if($fs != strlen($file)) die('STRLEN != FILESIZE');

echo "Filesize: ".number_format($fs,0,',','.')." Bytes\n";

$fb = bin2hex ($file[0]);

echo "First byte: ".$fb."\n";

if($fb != '0d' && $fb != '0e') die('invalid first byte!');

$chunks = array();
$fp = 0;

while($fb == '0d') {
	$chunksize = bin2hex ( $file[$fp+3].$file[$fp+2].$file[$fp+1] );
	$chunksize = hexdec ( $chunksize );
	$chunks[] = array($fp+4, $chunksize);
	
	$fp += $chunksize + 4;
	
	$fb = bin2hex ( $file[$fp] );
}

if($fb != '0e') die('invalid last chunk byte!');

$uncompressed_size = bin2hex ( $file[$fp+3].$file[$fp+2].$file[$fp+1] );
$uncompressed_size = hexdec ( $uncompressed_size );
$uncompressed_size += 65536 * count($chunks);

$chunksize = bin2hex ( $file[$fp+6].$file[$fp+5].$file[$fp+4] );
$chunksize = hexdec ( $chunksize );
$chunks[] = array($fp+7, $chunksize);

$fp += $chunksize + 7;

if($fp != $fs) die('couldnt reach end of file!');

echo "UncompressedFilesize: ".number_format($uncompressed_size,0,',','.')." Bytes\n";

echo "Chunks:\n";
for($i=1; $i <= count($chunks); $i++) {
	echo "\t$i. ".number_format($chunks[$i-1][1],0,',','.')." Bytes @ ".$chunks[$i-1][0]."\n";
}

for($i=0; $i < count($chunks); $i++) {
	echo "Decompress ".number_format($chunks[$i][1],0,',','.')." Bytes @ ".$chunks[$i][0]."\n";
	$out = decompress_pxp_chunk ( substr($file, $chunks[$i][0], $chunks[$i][1]) , $chunks[$i][1] );
	echo "Uncompressed chunksize: ".number_format(strlen($out),0,',','.')." Bytes\n";
	
	if($i==0) file_put_contents($out_file, $out);
	else file_put_contents($out_file, $out, FILE_APPEND);
}

$fsU = filesize($out_file);

if($fsU != $uncompressed_size) die('ERROR in decompression, couldnt reach expected filesize!');

function decompress_pxp_chunk($data, $size) {
	if($size < 4) {
		die('chunksize to small!');
	}
	$i = 0;
	$out = '';
	$chunkmode = 0;
	
	new_chunk_label:
	if(strlen($out) == 65536 || $i >= $size) {
		// end
		return $out;
	}
	/*
	Read 2 Bytes at the start of every sub chunk (each 4096 B of uncompressed data make one subchunk)
	*/
	$chunkybytes = bin2hex($data[$i++]).bin2hex($data[$i++]);
	echo "\$chunkybytes $chunkybytes => ";
	
	// try generic by 3. hexchar
	if($chunkybytes[2] == '1') $chunkmode = MODE_VERYMUCHNEAR;
	else if($chunkybytes[2] == '2') $chunkmode = MODE_VERYMUCHNEAR_DD;
	else if($chunkybytes[2] == '3') $chunkmode = MODE_VERYMUCHNEAR_Q4D;
	else if($chunkybytes[2] == '4') $chunkmode = MODE_VERYNEAR;
	else if($chunkybytes[2] == '5') $chunkmode = MODE_VERYNEAR_DD;
	else if($chunkybytes[2] == '6') $chunkmode = MODE_VERYNEAR_Q4D;
	else if($chunkybytes[2] == '7') $chunkmode = MODE_NEAR;
	else if($chunkybytes[2] == '8') $chunkmode = MODE_NEAR_DD;
	else if($chunkybytes[2] == '9') $chunkmode = MODE_NEAR_Q4D;
	else if($chunkybytes[2] == 'a') $chunkmode = MODE_FAR;
	else if($chunkybytes[2] == 'b') $chunkmode = MODE_FAR_DD;
	else if($chunkybytes[2] == 'c') $chunkmode = MODE_FAR_Q4D;
	else if($chunkybytes[2] == 'd') $chunkmode = MODE_VERYFAR;	
	else if($chunkybytes[2] == 'e') $chunkmode = MODE_VERYFAR_DD;	
	else if($chunkybytes[2] == 'f') $chunkmode = MODE_VERYFAR_Q4D;	
	else if($chunkybytes[2] == '0') $chunkmode = MODE_ZERO;	

	echo getConstChunkModeName($chunkmode)."\n";
	
	while($i < $size) {
		if($chunkmode!=MODE_ZERO){
			/*
			Read flag Byte
			*/
			$spacerbyte = ord($data[$i++]); // 0-255
			$spacerbyte = decbin($spacerbyte); // 01010101
			$spacerbyte = str_split($spacerbyte); // array(0,1,0,1,...)
		}else{
			$spacerbyte = array();
		}
		
		for($j=0; $j < 8; $j++) {
		
			$flag = array_pop($spacerbyte);
			
			if($flag && $flag == '1') {
				$distance = ord($data[$i++]);
				$length = ord($data[$i++]);
				
				if($chunkmode==MODE_VERYMUCHNEAR){
					$distance = (($length & 1) * 256) + $distance + 1;
					$length = (($length & 254) / 2) + 3;
				}else if($chunkmode==MODE_VERYMUCHNEAR_DD){
					$distance = (((($length & 1) * 256) + $distance) * 2) + 2;
					$length = (($length & 254) / 2) + 3;
				}else if($chunkmode==MODE_VERYMUCHNEAR_Q4D){
					$distance = (((($length & 1) * 256) + $distance) * 4) + 4;
					$length = (($length & 254) / 2) + 3;
				}else if($chunkmode==MODE_VERYNEAR){
					$distance = (($length & 3) * 256) + $distance + 1;
					$length = (($length & 252) / 4) + 3;
				}else if($chunkmode==MODE_VERYNEAR_DD){
					$distance = (((($length & 3) * 256) + $distance) * 2) + 2;
					$length = (($length & 252) / 4) + 3;
				}else if($chunkmode==MODE_VERYNEAR_Q4D){
					$distance = (((($length & 3) * 256) + $distance) * 4) + 4;
					$length = (($length & 252) / 4) + 3;
				}else if($chunkmode==MODE_NEAR){
					$distance = (($length & 7) * 256) + $distance + 1;
					$length = (($length & 248) / 8) + 3;
				}else if($chunkmode==MODE_NEAR_DD){
					$distance = (((($length & 7) * 256) + $distance) * 2) + 2;
					$length = (($length & 248) / 8) + 3;
				}else if($chunkmode==MODE_NEAR_Q4D){
					$distance = (((($length & 7) * 256) + $distance) * 4) + 4;
					$length = (($length & 248) / 8) + 3;
				}else if($chunkmode==MODE_FAR){
					$distance = (($length & 15) * 256) + $distance + 1;
					$length = (($length & 240) / 16) + 3;
				}else if($chunkmode==MODE_FAR_DD){
					$distance = (((($length & 15) * 256) + $distance) * 2) + 2;
					$length = (($length & 240) / 16) + 3;
				}else if($chunkmode==MODE_FAR_Q4D){
					$distance = (((($length & 15) * 256) + $distance) * 4) + 4;
					$length = (($length & 240) / 16) + 3;
				}else if($chunkmode==MODE_VERYFAR){
					$distance = (($length & 31) * 256) + $distance + 1;
					$length = (($length & 224) / 32) + 3;
				}else if($chunkmode==MODE_VERYFAR_DD){
					$distance = (((($length & 31) * 256) + $distance) * 2) + 2;
					$length = (($length & 224) / 32) + 3;
				}else if($chunkmode==MODE_VERYFAR_Q4D){
					$distance = (((($length & 31) * 256) + $distance) * 4) + 4;
					$length = (($length & 224) / 32) + 3;
				}else if($chunkmode==MODE_ZERO){
					// no compression
				}
							
				for($t = 0; $t < $length; $t++) {
					$out .= substr($out, -($distance), 1);
				}
				
			}else{
				if($i >= $size) return $out;
				
				$out .= $data[$i++];
			}
			
			if( is_int(strlen($out) / 4096) ) {
				goto new_chunk_label;
			}
		
		}
	}
	return $out;
}

function getConstChunkModeName($cm) {
	if($cm < 1) return "UNKNOWN";
	$all_consts = get_defined_constants(true);
	foreach($all_consts['user'] as $name => $value) {
		if(strpos($name, 'MODE_') === 0 && $value === $cm)
			return $name;
	}
	return "UNKNOWN";
}